import random, pyglet

class x_y_point(object):
    def __init__(self, x, y):
        self.x = x
        self.y = y

class nine_blocks(object):
    chosed = (255,0,255,200)
    unchose = (0,255,0,200)
    oh_chosed = (255,0,255,100)
    #block_values = random.sample(xrange(1,20), 9)
    blocks = []
    block_location = [x_y_point(0,0), x_y_point(1,0), x_y_point(2,0),
        x_y_point(0,1), x_y_point(1,1), x_y_point(2,1),
        x_y_point(0,2), x_y_point(1,2), x_y_point(2,2)]
    def __init__(self):
        self.now_commit = 0
        for i in range(0,9):
            bt = pyglet.text.Label('',
                    font_size=36,
                    x = ( self.block_location[i].x * 100 + 65 + 30 ),
                    y = ( self.block_location[i].y * 100 + 65 + 30 )
                )
                
            self.blocks.append(bt)
        self.set_blocks_values()
    
    def set_blocks_values(self):
        block_values = random.sample(xrange(1,20), 9)
        i = 0
        for v in block_values:
            self.blocks[i].text = str(v)
            i += 1
            
    def hit_block(self, value):
        for t in self.blocks:
            if t.text == str(value):
                if t.color == self.unchose:
                    t.color = self.chosed
                else: t.color = self.unchose
    def commit_happen(self):
        self.now_commit = 1
        for t in self.blocks:
            if t.color == self.chosed:
                t.color = self.oh_chosed
    
    def after_comment(self):
        if self.now_commit:
            self.set_blocks_unchoice()
        self.now_commit = 0
    
    def set_blocks_unchoice(self):
        for t in self.blocks:
            t.color = self.unchose

    def find_answer(self):
        self.answer_values = []
        self.answer_sum = 0
        self.answer_msg = ""
        for s in self.blocks:
            if s.color == self.chosed:
                si = int(s.text)
                self.answer_values.append(si)
                self.answer_sum += si
        if len(self.answer_values) > 0:
            self.answer_values.sort()
            self.answer_values.reverse()
            self.answer_msg = str(self.answer_values[0])
            for s in xrange(len(self.answer_values) - 1):
                self.answer_msg += ' + %s' %str(self.answer_values[s + 1])
            self.answer_msg += ' = %s' %str(self.answer_sum)

class query_block(object):
    def __init__(self, nine_blocks):
        self.blocks = nine_blocks.blocks
    def query_m_hit(self, xy_point):
        for i in xrange(len(self.blocks)):
            if ( 
                    ( xy_point.x > self.blocks[i].x ) and 
                    ( xy_point.y > self.blocks[i].y ) 
                ) and ( 
                    ( xy_point.x < ( self.blocks[i].x + 50 ) ) and 
                    ( xy_point.y < ( self.blocks[i].y + 50 ) )
                ):
                return int(self.blocks[i].text), i
        return False, 0
        
class make_a_question(object):
    charlist = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i']
    def set_values(self, nine_blocks):
        self.values = []
        for s in nine_blocks.blocks:
            self.values.append(int(s.text))
    def make_question_blocks(self, level=1):
        self.question_blocks_len = level + 1
        self.question_blocks = random.sample(self.values, self.question_blocks_len)
        self.question_blocks.sort()
        self.question_blocks.reverse()
        self.qbv_sum = 0
        
        for v in self.question_blocks:
            self.qbv_sum += v
        self.sum_question = 'a'
        self.sum_answer = str(self.question_blocks[0])
        for i in xrange(self.question_blocks_len - 1):
            self.sum_question += ' + %s' %self.charlist[i + 1]
            self.sum_answer += ' + %s' %self.question_blocks[i + 1]
        self.sum_question += ' = %s' %str(self.qbv_sum) 
        self.sum_answer += ' = %s' %str(self.qbv_sum) 
